.model small
.stack
.data
BUFSIZE EQU 20480 ; nuskaitymo buferis, su didesnio dydzio failais nesusidoros
file1 db 20 dup (0) ; stringas pirmo failo pavadinimui
file2 db 20 dup (0) ; antro failo pavadinimui
hlp db 'Programa palyginanti du failus.', 10 , 13, 'fcomp file1.txt file2.txt $' ; help'o zinute
msg3 db 10, 13, 'Failas nerastas.', 10, 13, '$'
msg1 db 10, 13, 'Failai nelygaus dydzio.', 10, 13, 'Bus lygimana tiek baitu, kiek ju yra mazesniame faile.', 10, 13,'$'
msg2 db 10, 13, 10, 13, 'Priejome pirmo failo pabaiga.',10, 13,  '$'
msg4 db 10, 13, 10, 13, 'Priejome antro failo pabaiga.', 10, 13, '$'
msg5 db 10, 13, 'Rezultatai pateikiami tokiu formatu:',10, 13,'<pozicija>-<pirmo failo simbolis>-<antro failo simbolis>', '$'
handle1 dw ? ; failu "rankenos"
handle2 dw ?
output db 10, 13, '----------$' ; isvedimo eilute
CmdLnLen equ byte ptr es:[80h] ; komandines eilutes parametru eilute
CmdLn equ byte ptr es:[81h] ; kiek baitu uzima komandines eilutes parametrai
buffer1 db BUFSIZE dup ('$') ; buferis nuskaitymui is pirmo failo
buffer2 db BUFSIZE dup ('$') ; buferiukas antram failui
.code
	mov ax, @data
	mov ds,ax
	cmp CmdLnLen, 0 ; ar yra komadines eilutej kaskors ivesta
	je help ; jei nera, spausdima helpo pranesima
	sub bx, bx
	sub cx, cx
	mov cl, CmdLnLen ; cikla suksim tiek kartu, kie baitu kom. eilt
next:
    cmp CmdLn[bx], '/' ; ieskom "/" simbolio
    jne nohelp
    inc bx			; ziurim kita simboli	
    dec cl			; pakoreguojam ciklo sukimo kartu skaiciu
    cmp CmdLn[bx], '?' ; jei radom ziurim ar po jo eina "?"
    jne nohelp	
help:    				; jei eina, spausdinam helpa ir baigiam programa 
	mov ah, 9
	mov dx, offset hlp
	int 21h
	mov dx, offset msg5
	int 21h
	jmp theend
nohelp:				; helpo dar neprireike	
	inc bx			; pereinam prie kito simbolio
	loop next
	
	mov bx, 0		
	mov di, 0		; paruosiam indeksinius regitrus
	mov si, 0		; griztam vel i parm. eil. pradzia
	sub dx, dx 		; dx=0 rasom irasinejam pirmo failo pavadinima, dx=1 antro 
	sub cx, cx
	mov cl, CmdLnLen ;vel nustatom ciklo kartojimo skaiciu
 
    
doit:
	cmp  CmdLn[si], ' '	; ieskom tarpu, tarpas reiskia pirmo filename pabaiga
	jne rasom    ; sokam irashyt simboli
	inc dx		; pakeiciam rashymo vieta
	jmp kitas	; einam prie kito simbolio
rasom:
	cmp dx, 1   ; ziurim i kuri stringa rashyt
	jg rasom2
	mov al, CmdLn[si] ; irasom simboli
	mov file1[bx], al
	inc bx            ; padidinam indeska
	jmp kitas	; preinam pir kito simbolio
rasom2:
	mov al, CmdLn[si] ; analogiskai
    mov file2[di], al
	inc di
kitas:
	inc si
	loop doit

	
	mov ah, 3dh ; bandysim atidaryti faila
	mov al, 0 ; skaitymui
	mov dx, offset file1 ; pavadinimu koki nuskaitem
	int 21h
	mov handle1, ax ; perduodam "rankena"
	mov ah, 59h ; ziurim ar klaida
	int 21h
	cmp al, 2
	je deflt ; klaida, isvedam pranesima nutraukiam darba
	
	mov ah, 3dh ; bandysim atidaryti faila
	mov al, 0 ; skaitymui
	mov dx, offset file2 ; pavadinimu koki ivede
	int 21h
	mov handle2, ax ; perduodam "rankena"
	mov ah, 59h ; ziurim ar klaida
	int 21h
	cmp al, 2
	je deflt ; klaida, isvedam pranesima nutraukiam darba
	
	jmp skaitom
	
deflt:    
	sub ax, ax
    mov ah, 9
	mov dx, offset msg3  ; zinute, kad nurodyto failo nera
	int 21h
	jmp theend   ; baigiam
	
	
	
skaitom:
	
	mov ah, 3fh ; skaitymo f-ja
	mov bx, handle1
	mov cx, BUFSIZE ; skaitysim tiek baitu kiek buferio dydis
	mov dx, offset buffer1 ; i DS:DX
	int 21h	
	mov si, ax ; kiek baitu nuskaitem

	
	
	mov ah, 3fh ; skaitymo f-ja
	mov bx, handle2
	mov cx, BUFSIZE ; skaitysim tiek baitu kiek buferio dydis
	mov dx, offset buffer2 ; i DS:DX
	int 21h	
	mov di, ax ; kiek baitu nuskaitem

	cmp si, di ; ziurim ar vienodi ilgiai
	jne not_equal
	mov cx, si
	jmp	comp
	

	
not_equal: ; ilgiai nevienodi
	mov ah, 9
	mov dx, offset msg1 ; pranesam apie tai
	int 21h
	
	push si       
	sub si, di
	cmp si, 0    ; ziurim kuris mazesnis
	jg b1_bigger
	pop si
	mov cx, si  ; pagal ta ir darysim cikla
	push 0      ; nustatyt kuris buvo mazesnis
	jmp comp
b1_bigger:
	push 1   ; ; nustatyt kuris buvo mazesnis
	dec di
	mov si, di
	mov cx, di

comp:
	mov al, buffer1[si]
	cmp al, buffer2[di] ; lyginam simbolius
	je match  ; jeigu lygus
	mov bx, 7
	mov ax, si
mismatch:
	mov dl, 10     
	div dl          ; pozicijos nr. dalinam is 10
	add ah, 30h     ; liekanos skaicius pavercia atitinkamu ascii kodu
	mov output[bx], ah  ; irasom i reikiam isvedimo eilutes vieta
	dec bx              ; nustatom tika isvedimo eilutes pozicija
	sub ah, ah			; istrinam liekana
	cmp bx, 2			; ziurim ar dar neuzpildem isvedimo eilutes (pirmi du simboliai: 10, 13)
	jge mismatch		; jei ne kartojam procedura
	mov bx, 9			; preinam prie reikiamos isvedimo eilutes vietos
	mov al, buffer1[si] 
	mov output[bx], al ; irasom nesutampanti simboli is pirmo failo
	mov bx, 11			; pereinam i kita vieta
	mov al, buffer2[si]
	mov output[bx], al  ; irasom nesutampanti simboli is antro failo
	mov ah, 9
	mov dx, offset output  ; atspausdinam isvedimo eilute
	int 21h
match:                ; jei simboliai sutampa
	dec si			; tiesiog pereinam prie kitos poros
	dec di
	loop comp
	
	pop dx        
	cmp dx, 0  ; paziurim kurio failo pabaiga priejom
	jne scnd
	mov ah, 9
	mov dx, offset msg2 ; isvedam atitinkama pranesima
	int 21h
scnd:
	cmp dx, 1
	jne theend
	mov ah, 9
	mov dx, offset msg4 ; isvedam atitinkama pranesima
	int 21h

theend:            ; pabaiga
	mov ah, 4ch
	int 21h
end